ProofreadPage extension needs to be refactored
Closed, ResolvedPublic


This request has been copied from Tpt's proposal at

"The Proofread Page extension is an old extension developed by the Wikisource community that manage the Wikisource Proofreading system. It needs some love in order to make it use new technologies of MediaWiki core and to integrate it into the Visual Editor. Here is a list of some tasks that should be done:

  • Refactoring of the extension code by splitting the very big file ProofreadPage.body.php that do too much things into specific classes what will be more easily testable. Write unit tests for them.
  • Refactoring of the JavaScript module that manages edition of Page: and make it compatible with the Visual Editor. This includes:
      • for wikitext editing system a full rewrite in order to make the code readable and testable. The tasks would be:
        • move to server part of the extension things that can be done by it as it have been done for Index: pages.
        • use libraries packaged with MediaWiki like JQuery when possible.
        • find and use a good free JS library for zooming into scans in order to improve the current zoom feature that might be enhanced.
      • work with the Visual Editor team in order to make the Visual Editor
    • work with Page: pages (bugzilla). The first step is to make the body of the page editable, then the proofreading level and, if it's possible, header and footer.
  • Add modules to the Visual Editor to support specific tags used by Wikisource like <pages>, <section> and <poem>.
  • Allows to edit using the Visual Editor textareas of the Index: pages form."

Version: unspecified
Severity: enhancement
Whiteboard: aklapper-moreinfo


bzimport raised the priority of this task from to Low.
bzimport set Reference to bz46616.
Qgil created this task.Mar 27 2013, 9:19 PM
Qgil added a comment.Mar 27 2013, 9:45 PM

This request is now listed at

We will feature it as a project idea for Google Summer of Code and the Outreach Program for Women.

aartidwivedi19 wrote:

ProofreadPage uses too many global variables. I suppose we could count this issue also while we are on this project.

Qgil added a comment.Apr 27 2013, 4:36 AM

Just a note to say that Aarti Dwivedi has submitted a proposal related to this report for Google Summer of Code and Outreach Program for Women.

ellydwivedi2093 wrote:

Update: Proposal has been accepted. I have started coding and the first change is here ->
The progress can be tracked at

Qgil added a comment.Sep 17 2013, 4:11 PM

GSoC "soft pencils down" date was yesterday and all coding must stop on 23 September. Has this project been completed?

ellydwivedi2093 wrote:

The refactoring part is done. The changes are on pagePagesRefactoring branch. The branch will be merged to master.

Qgil added a comment.Oct 22 2013, 7:34 PM

If you have open tasks or bugs left, one possibility is to list them at and volunteer yourself as mentor.

We have heard from Google and free software projects participating in Code-in that students participating in this programs have done a great work finishing and polishing GSoC projects, many times mentores by the former GSoC student. The key is to be able to split the pending work in little tasks.

More information in the wiki page. If you have questions you can ask there or you can contact me directly.

Qgil added a comment.Dec 17 2013, 7:53 PM

Hi, what is missing to resolve this report as FIXED?

Tpt / Aarti: What is missing here?

Tpt added a comment.Jan 9 2014, 2:12 PM

The parts of the code mentioned in the first comment are refactored now so I think we may close the bug even if some background work remains to do.

GOIII moved this task from Backlog to Done on the ProofreadPage board.Jun 12 2016, 3:46 AM